#!/usr/bin/env python

"""Tool untuk menyalakan dan mematikan komputer secara remote dalam jaringan"""

import wx
import wx.lib.buttons as buttons
import wake_on_lan, client

daftar = open("daftar-komputer.txt","rb")
hasil = daftar.readlines()
daftar.close()
listarp = {}    #listarp adalah daftar arp berbentuk dictionary (ip:arp)
alamatip = []   #daftar alamat ip berupa list
daftarhost = [] #daftar nama host berupa list
ID = []         #daftar id untuk tombol
##print hasil

kolom = 6       #banyak kolom
hgap = 12       #jarak horizontal antar tombol
vgap = 10       #jarak vertikal antar tombol
panjang = 120   #panjang tombol
lebar = 65      #lebar tombol

for line in hasil:
    L = line.split()
    alamatip.append(L[0])
    listarp[L[0]] = L[1]
    daftarhost.append(L[2])

##print listarp
jumlah = len(alamatip)    
ID = range(jumlah)
PC = ID

class MyApp(wx.App):
    def OnInit(self):
       frame = MyFrame("WakeUp-Shutdown", (60, 40), (800, 550),
                        wx.DEFAULT_FRAME_STYLE)
       frame.Show()
       self.SetTopWindow(frame)
       return True
class MyFrame(wx.Frame):
    def __init__(self, title, pos, size, style):
        wx.Frame.__init__(self, None, -1, title, pos, size, style)
        bmp = wx.Image("iMac.png", wx.BITMAP_TYPE_ANY).ConvertToBitmap()
        bmpoff = wx.Image("iMac2.png", wx.BITMAP_TYPE_ANY).ConvertToBitmap()
        bmpunused = wx.Image("unused.png", wx.BITMAP_TYPE_ANY).ConvertToBitmap()
        menuFile = wx.Menu()
        menuFile.Append(101, "&Tentang...", "Informasi mengenai aplikasi")
        menuFile.AppendSeparator()
        menuFile.Append(102, "&Keluar", "Keluar dari program?")
        menuFile2 = wx.Menu()   
        gambar1 = wx.Bitmap("exit.png", wx.BITMAP_TYPE_ANY)
        item1 = wx.MenuItem(menuFile2, 103, "&Matikan Semua", 
                            "Matikan semua komputer")
        item1.SetBitmap(gambar1)
        menuFile2.AppendItem(item1)
        gambar2 = wx.Bitmap("wake.png", wx.BITMAP_TYPE_ANY)
        item2 = wx.MenuItem(menuFile2,104, "Menyalakan &Semua", 
                            "Menyalakan semua komputer")
        item2.SetBitmap(gambar2)
        menuFile2.AppendItem(item2)
        menuBar = wx.MenuBar()
        menuBar.Append(menuFile, "&File")
        menuBar.Append(menuFile2, "S&pesial")
        self.SetMenuBar(menuBar)
        self.CreateStatusBar()        
        self.Bind(wx.EVT_MENU, self.OnAbout, id=101)
        self.Bind(wx.EVT_MENU, self.OnQuit, id=102)
        self.Bind(wx.EVT_MENU, self.ShutdownAll, id=103)
        self.Bind(wx.EVT_MENU, self.WakeAll, id=104)
        #notebook
        notebook = wx.Notebook(self, -1)
        #sizer
        sizer = wx.FlexGridSizer(1,kolom,vgap,hgap)
        sizer2 = wx.FlexGridSizer(1,kolom,vgap,hgap)
        sizer3 = wx.GridBagSizer(hgap, vgap)
        #scroll-satu
        scroll = wx.ScrolledWindow(notebook, -1)
        scroll.SetScrollbars(1, 1, 900, 600)
        notebook.AddPage(scroll, "Menyalakan")
        
        for n in PC :
            indeks = n
            if alamatip[n] == '-' :
                scroll.button = buttons.GenBitmapTextButton(scroll, ID[indeks],
                                bmpunused, size=(panjang, lebar))
                scroll.button.Enable(False)
                sizer.Add(scroll.button)
            else :
                scroll.button = buttons.GenBitmapTextButton(scroll, ID[indeks],
                                bmp,"%s \n\t%s" % (alamatip[indeks],
                                daftarhost[indeks]), size=(panjang, lebar))
                scroll.button.SetUseFocusIndicator(False)
                sizer.Add(scroll.button)
                scroll.Bind(wx.EVT_BUTTON, self.WakeUp, scroll.button)
        scroll.SetSizer(sizer)
        
        #scroll-dua
        scroll2 = wx.ScrolledWindow(notebook, -1)
        scroll2.SetScrollbars(1, 1, 900, 600)
        notebook.AddPage(scroll2, "Mematikan")

        for m in PC :
            indeks = m
            if alamatip[m] == '-' :
                scroll2.button = buttons.GenBitmapTextButton(scroll2,ID[indeks],
                                bmpunused,size=(panjang, lebar))
                scroll2.button.Enable(False)
                sizer2.Add(scroll2.button)
            else :
                scroll2.button = buttons.GenBitmapTextButton(scroll2,ID[indeks],
                                bmp,"%s \n\t%s" % (alamatip[indeks],
                                daftarhost[indeks]), size=(panjang, lebar))
                scroll2.button.SetUseFocusIndicator(False)
                sizer2.Add(scroll2.button)
                scroll2.Bind(wx.EVT_BUTTON, self.Shutdown, scroll2.button)
        scroll2.SetSizer(sizer2)
        
        
    def OnQuit(self, event):
        box = wx.MessageDialog(self, "Yakin mau keluar ???", "Keluar ?",
                        wx.YES_NO | wx.ICON_QUESTION )
        retCode = box.ShowModal()
        if retCode == wx.ID_YES :
            self.Close()
        else :
            pass
        
    def OnAbout(self, event):
        wx.MessageBox("Ini adalah aplikasi untuk menyalakan dan mematikan"
                      " komputer secara remote di dalam jaringan\n\n",
                "About WakeDown", wx.OK | wx.ICON_INFORMATION, self)
                
    def WakeUp(self, event):
        id = event.GetId()
        ip = alamatip[id]
        wake_on_lan.WakeOnLan(listarp.get(ip))
                
    def WakeAll(self, event) :
        for x in PC :
            ip = alamatip[x]
            wake_on_lan.WakeOnLan(listarp.get(ip))

    def Shutdown(self, event):
        id = event.GetId()
        host = alamatip[id]
        client.matikan(host)
##        wx.MessageBox(pesan,"Title", wx.OK | wx.ICON_INFORMATION,self)     
        
    def ShutdownAll(self, event) :
        for z in PC :
            host = alamatip[z]
            client.matikan(host)
##        wx.MessageBox("Mematikan", "Title", wx.OK | wx.ICON_INFORMATION, self)
                
                
if __name__ == '__main__':
    app = MyApp()
    app.MainLoop()
